﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Text.RegularExpressions;

namespace game.Model
{
    public class GameSettings
    {
        private bool Sound = false;         //true - sound ON, false sound OFF
        private bool EffectsSound = false;  //true - sound ON, false sound OFF
        private bool Hardness = false;      //true - simple (big images), false - hard (small images)

        public GameSettings() {
            setSound(true);
            setEffectsSound(true);
            setHardness(true);
        }

        public GameSettings(String s)
        {
            string[] sets = Regex.Split(s, ",");
            if (int.Parse(sets[0]) == 1)
                setSound(true);
            if (int.Parse(sets[1]) == 1)
                setEffectsSound(true);
            if (int.Parse(sets[2]) == 1)
                setHardness(true);
        }

        public GameSettings(bool s,bool h)
        {
            setSound(s);
            setHardness(h);
            setEffectsSound(h);
        }

        public void setSound(bool value)
        {
            this.Sound = value;
        }

        public void setHardness(bool value)
        {
            this.Hardness = value;
        }

        public void setEffectsSound(bool value)
        {
            this.EffectsSound = value;
        }

        public bool getSound()
        {
            return this.Sound;
        }

        public bool getHardness()
        {
            return this.Hardness;
        }

        public bool getEffectsSound()
        {
            return this.EffectsSound;
        }

        public String toString() {
            String s = "0";
            String h = "0";
            String e = "0";

            if (Sound)
                s = "1";
            if (Hardness)
                h = "1";
            if (EffectsSound)
                e = "1";
            return s + "," + e + "," + h;
        }

    }
}
