﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Windows.Media.Imaging;
using System.Threading;
using game.Pages;

namespace game.Model
{
    public class GridMonitor : INotifier
    {
        GameGrid grid;
        TextBlock area;
        String iconToFind;
        int itconIntances;
        IGame game;

        public GridMonitor(IGame igame, TextBlock area)
        {
            grid = new GameGrid();
            grid.AddNotifier(this);
            this.game = igame;
            this.area = area;
        }

        public GameGrid getGrid() {
            return grid;
        }

        public void setRowsAndCols(int numRows, int numCols) {
            grid.InitializeGrid(numRows, numCols);
        }

        public void setIcons(int num){            
            //grid.addIcons(num);
            for (int i = 0; i < num; i++) {
                grid.addIcon2();
            }
        }

        public void fullIcons() {
            grid.fullIcons();
        }

        public void addAnotherIcon() {
            grid.addIcon2();
        }

        public Dictionary<String, int> getIconNames()
        {
            return grid.getIconsName();
        }

        public GameGrid getGridx() {
            return grid;
        }

        public String notification(String message, Object sender)
        {
            //logic when an icon is pressed comes here
            Button buttonPressed = (Button)sender;
            
            //GOOD MOVE
            if (iconToFind.Equals( (String)buttonPressed.Tag , StringComparison.Ordinal))
            {
                //remove
                grid.removeIcon(buttonPressed);

                //change left
                itconIntances--;
                //update instances left
                area.Text = iconToFind + " x " + itconIntances;
                //if all intances has been reached
                if (itconIntances == 0)
                {
                    //notify the view (GAME) for points
                    game.goodMove();
                    toFind();
                }
                else
                {
                    game.semiGoodMove();
                }
            }else{

            //BAD MOVE
                //notify view (game) for less time or whatever
                game.wrongMove();
                grid.Disable((Button)sender);
            }

            return "";
        }

        public void toFind() {

            if (getIconNames().Count == 0)
            {
                game.noMovesLeft();
                return;
            }

            grid.EnableAll();
            
            Random r = new Random(DateTime.Now.Millisecond);
            int num = 0;
            if (getIconNames().Count > 1)
                num = r.Next(0, getIconNames().Count - 1);
            List<String> keys = new List<String>(getIconNames().Keys);
            iconToFind = keys[num];
            itconIntances = getIconNames()[keys[num]];

            area.Text = iconToFind + " x " + itconIntances;
        }

        public void stop() {
            grid.DisableAll();
        }

    }
}
