﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO.IsolatedStorage;
using System.IO;

namespace game.Model
{
    public partial class ReadWrite
    {

        public void SaveData(string data, string fileName)
        {
            using (IsolatedStorageFile isf = IsolatedStorageFile.GetUserStoreForApplication())
            {
                using (IsolatedStorageFileStream isfs = new IsolatedStorageFileStream(fileName, FileMode.Create, isf))
                {
                    using (StreamWriter sw = new StreamWriter(isfs))
                    {
                        sw.Write(data);
                        sw.Close();
                    }
                }
            }
        }

        public string LoadData(string fileName)
        {

            IsolatedStorageFile myStore = IsolatedStorageFile.GetUserStoreForApplication();
            StreamReader readFile = null;

            if(  !myStore.FileExists(fileName)){
                //create
                if (fileName.Equals("settings.txt", StringComparison.OrdinalIgnoreCase))
                    SaveData("1,1,1", fileName);
                else
                    SaveData("", fileName);
            }

            String temp = "";
            try
            {
                readFile = new StreamReader(new IsolatedStorageFileStream(fileName, FileMode.Open, myStore));
                temp = readFile.ReadLine();
                readFile.Close();
            }
            catch { }
            
            return temp;
        }


        public void TruncateData(string fileName)
        {

            IsolatedStorageFile myStore = IsolatedStorageFile.GetUserStoreForApplication();
            StreamReader readFile = null;
            try
            {
                readFile = new StreamReader(new IsolatedStorageFileStream(fileName, FileMode.Truncate, myStore));
            }
            catch { }
        }
    }
}
