﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using game.Model;



namespace game.Pages
{
    public partial class HomePage : PhoneApplicationPage
    {
        MainPage main;
        public HomePage(MainPage main)
        {
            this.main = main;
            InitializeComponent();
            buttonStart.Click += buttonStartClicked;
            buttonScores.Click += new RoutedEventHandler(viewScores);
            buttonHelp.Click += new RoutedEventHandler(viewInstructions);
            
        }

        public void init() {
            ReadWrite rw = new ReadWrite();
            ActualState actualState = new ActualState(rw.LoadData("state.txt"));
            if (!actualState.defaultState)
                buttonStart.Content = "Resume";
            else
                buttonStart.Content = "Start";
        }


        void viewScores(object sender, RoutedEventArgs e)
        {
            if (main.gameSettings.getEffectsSound())
            {
                main.soundEffect.SetupSoundEffect("sounds/click.wav");
                main.soundEffect.Play();
            }
            main.NavigationService.Navigate(new Uri("/Pages/panoramaPage.xaml?view=1", UriKind.Relative));
            //main.goToPanorama(this, 1);
        }

        void viewInstructions(object sender, RoutedEventArgs e)
        {
            if (main.gameSettings.getEffectsSound())
            {
                main.soundEffect.SetupSoundEffect("sounds/click.wav");
                main.soundEffect.Play();
            }
            main.NavigationService.Navigate(new Uri("/Pages/panoramaPage.xaml?view=0", UriKind.Relative));
            //main.goToPanorama(this, 0);
        }

        public void buttonStartClicked(Object o, EventArgs e)
        {
            if (main.gameSettings.getEffectsSound())
            {
                main.soundEffect.SetupSoundEffect("sounds/click.wav");
                main.soundEffect.Play();
            }
            main.goToGame(this);
        }

        public void buttonSettingsClicked(Object o, EventArgs e)
        {
            if (main.gameSettings.getEffectsSound())
            {
                main.soundEffect.SetupSoundEffect("sounds/click.wav");
                main.soundEffect.Play();
            }
            main.goToSettings(this);
        }


        private void mouseD(object sender, MouseButtonEventArgs e)
        {
            pressed(sender);
        }

        private void mouseU(object sender, MouseButtonEventArgs e)
        {
            unPressed(sender);
            String imgName = ((Image)sender).Name;

            if (imgName.Equals("SettingsIcon"))
            {
                //Model.Timer timer = new Model.Timer(1, main);
                //main.goToSettings(this);
                main.NavigationService.Navigate(new Uri("/Pages/Settings.xaml", UriKind.Relative));
            }
        }

        private void mouseL(object sender, MouseEventArgs e)
        {
            unPressed(sender);
        }

        private void pressed(object sender)
        {
            ImageSourceConverter c = new ImageSourceConverter();
            String imgName = ((Image)sender).Name;
            ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/" + imgName + "D.PNG");
        }

        private void unPressed(object sender)
        {
            ImageSourceConverter c = new ImageSourceConverter();
            String imgName = ((Image)sender).Name;
            ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/" + imgName + "U.PNG");
        }

    }
}