﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Threading;
using game.Model;

namespace game.Pages
{
    public partial class Settings : PhoneApplicationPage
    {
        //MainPage main;
        bool effectSounds;
        bool sound;
        bool hardness;

        public SoundPlayer playSound;
        public SoundEffectAction soundEffect;
        public GameSettings gameSettings;

        public Settings()
        {
            //this.main = main;
            InitializeComponent();

            ReadWrite rw = new ReadWrite();
            gameSettings = new GameSettings(rw.LoadData("settings.txt"));
            //body.Children.Add(intro);
            playSound = new SoundPlayer(this);

            soundEffect = new SoundEffectAction();
            soundEffect.SetupSoundEffect("sounds/goodmove.wav");
            setIcons();
        }


        private void mouseD(object sender, MouseButtonEventArgs e)
        {
            pressed(sender);
        }

        private void setIcons()
        {
            ImageSourceConverter c = new ImageSourceConverter();

            effectSounds = gameSettings.getEffectsSound();
            if (effectSounds)
            {
                ESImage.Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
            }
            else
            {
                ESImage.Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
            }
            sound = gameSettings.getSound();
            if (sound)
            {
                GSImage.Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
            }
            else
            {
                GSImage.Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
            }
            hardness = gameSettings.getHardness();
            if (hardness)
            {
                HImage.Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
            }
            else
            {
                HImage.Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
            }
        }

        private void mouseU(object sender, MouseButtonEventArgs e)
        {

            unPressed(sender);
            effectSounds = gameSettings.getEffectsSound();
            sound = gameSettings.getSound();
            hardness = gameSettings.getHardness();

            String imgName = ((Image)sender).Name;
            if (gameSettings.getEffectsSound())
                playSound.playSound(new Uri("sounds/slide.mp3", UriKind.Relative));

            if (imgName.Equals("GSImage"))
            {
                if (sound)
                {
                    gameSettings.setSound(false);
                }
                else
                {
                    gameSettings.setSound(true);
                }
            }

            if (imgName.Equals("ESImage"))
            {
                if (effectSounds)
                {
                    gameSettings.setEffectsSound(false);
                }
                else
                {
                    gameSettings.setEffectsSound(true);
                }
            }

            if (imgName.Equals("HImage"))
            {
                if (hardness)
                {
                    gameSettings.setHardness(false);
                }
                else
                {
                    gameSettings.setHardness(true);
                }
            }

        }

        private void mouseL(object sender, MouseEventArgs e)
        {
            unPressed(sender);
        }

        private void pressed(object sender)
        {
            effectSounds = gameSettings.getEffectsSound();
            sound = gameSettings.getSound();
            hardness = gameSettings.getHardness();

            ImageSourceConverter c = new ImageSourceConverter();
            String imgName = ((Image)sender).Name;
            if (imgName.Equals("GSImage"))
            {
                if (sound)
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
                }
                else
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
                }
            }

            if (imgName.Equals("ESImage"))
            {
                if (effectSounds)
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
                }
                else
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
                }
            }

            if (imgName.Equals("HImage"))
            {
                if (hardness)
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
                }
                else
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
                }
            }



        }

        private void unPressed(object sender)
        {
            ImageSourceConverter c = new ImageSourceConverter();
            String imgName = ((Image)sender).Name;
            if (imgName.Equals("GSImage"))
            {
                if (sound)
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
                    sound = false;
                }
                else
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
                    sound = true;
                }
            }

            if (imgName.Equals("ESImage"))
            {
                if (effectSounds)
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
                    effectSounds = false;
                }
                else
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
                    effectSounds = true;
                }
            }

            if (imgName.Equals("HImage"))
            {
                if (hardness)
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myOFF.png");
                    hardness = false;
                }
                else
                {
                    ((Image)sender).Source = (ImageSource)c.ConvertFromString("../Images/myON.png");
                    hardness = true;
                }
            }
        }

        protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {

            if (gameSettings.getEffectsSound())
            {
                soundEffect.SetupSoundEffect("sounds/click.wav");
                soundEffect.Play();
            }
            if (sound)
                gameSettings.setSound(true);
            else
                gameSettings.setSound(false);
            if (effectSounds)
                gameSettings.setEffectsSound(true);
            else
                gameSettings.setEffectsSound(false);
            if (hardness)
                gameSettings.setHardness(true);
            else
                gameSettings.setHardness(false);

            ReadWrite rw = new ReadWrite();
            rw.SaveData(gameSettings.toString(), "settings.txt");
        }




    }


}